﻿using SelfPropelledArtilleryUnit.Entities;
using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SelfPropelledArtilleryUnit.Drawnings;

public class DrawiningPropelledArtilleryEqutables : IEqualityComparer<DrawningPropelledArtillery?>
{
    public bool Equals(DrawningPropelledArtillery? x, DrawningPropelledArtillery? y)
    {
        if (x == null || x.EntityPropelledArtillery == null)
        {
            return false;
        }
        if (y == null || y.EntityPropelledArtillery == null)
        {
            return false;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }
        if (x.EntityPropelledArtillery.Speed != y.EntityPropelledArtillery.Speed)
        {
            return false;
        }
        if (x.EntityPropelledArtillery.Weight != y.EntityPropelledArtillery.Weight)
        {
            return false;
        }
        if (x.EntityPropelledArtillery.BodyColor != y.EntityPropelledArtillery.BodyColor)
        {
            return false;
        }
        if (x is DrawningSelfPropelledArtilleryUnit && y is DrawningSelfPropelledArtilleryUnit)
        {
            EntitySelfPropelledArtilleryUnit _x = (EntitySelfPropelledArtilleryUnit)x.EntityPropelledArtillery;
            EntitySelfPropelledArtilleryUnit _y = (EntitySelfPropelledArtilleryUnit)x.EntityPropelledArtillery;
            if (_x.AdditionalColor != _y.AdditionalColor)
            {
                return false;
            }
            if (_x.TurretCannon != _y.TurretCannon)
            {
                return false;
            }
            if (_x.LaunchBattery != _y.LaunchBattery)
            {
                return false;
            }
        }
        return true;
    }
    public int GetHashCode([DisallowNull] DrawningPropelledArtillery obj)
    {
        return obj.GetHashCode();
    }
}
