﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SelfPropelledArtilleryUnit.Drawnings;
/// <summary>
/// Сравнение по цвету, скорости, весу
/// </summary>
public class DrawningPropelledArtilleryCompareByColor : IComparer<DrawningPropelledArtillery?>
{
    public int Compare(DrawningPropelledArtillery? x, DrawningPropelledArtillery? y)
    {
        if (x == null || x.EntityPropelledArtillery == null)
        {
            return 1;
        }

        if (y == null || y.EntityPropelledArtillery == null)
        {
            return -1;
        }
        var bodycolorCompare = x.EntityPropelledArtillery.BodyColor.Name.CompareTo(y.EntityPropelledArtillery.BodyColor.Name);
        if (bodycolorCompare != 0)
        {
            return bodycolorCompare;
        }
        var speedCompare = x.EntityPropelledArtillery.Speed.CompareTo(y.EntityPropelledArtillery.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return x.EntityPropelledArtillery.Weight.CompareTo(y.EntityPropelledArtillery.Weight);
    }
}
