﻿using SelfPropelledArtilleryUnit.Drawnings;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SelfPropelledArtilleryUnit.CollectionGenericObjects;
/// <summary>
/// Сравнение по типу, скорости, весу
/// </summary>
public class DrawningPropelledArtilleryCompareByType : IComparer<DrawningPropelledArtillery?>
{
    public int Compare(DrawningPropelledArtillery? x, DrawningPropelledArtillery? y)
    {
        if (x == null || x.EntityPropelledArtillery == null)
        {
            return 1;
        }

        if (y == null || y.EntityPropelledArtillery == null)
        {
            return -1;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return x.GetType().Name.CompareTo(y.GetType().Name);
        }

        var speedCompare = x.EntityPropelledArtillery.Speed.CompareTo(y.EntityPropelledArtillery.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return x.EntityPropelledArtillery.Weight.CompareTo(y.EntityPropelledArtillery.Weight);
    }
}
